Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# EggTextureCollection Class Reference

This is a collection of textures by TRef name. More...

List of all members.

## Public Member Functions
| EggTextureCollection ()
| EggTextureCollection (EggTextureCollection const copy)
bool | addTexture (EggTexture texture)
| Explicitly adds a new texture to the collection.
| clear ()
| Removes all textures from the collection.
int | collapseEquivalentTextures (int eq, EggGroupNode node)
| Walks through the collection and collapses together any separate textures that are equivalent according to the indicated equivalence factor, eq (see EggTexture.is_equivalent_to()).
int | collapseEquivalentTextures (int eq, mapPointerToEggTexture, PointerToEggTexture removed)
| Walks through the collection and collapses together any separate textures that are equivalent according to the indicated equivalence factor, eq (see EggTexture.is_equivalent_to()).
EggTexture | createUniqueTexture (EggTexture const copy, int eq)
| Creates a new texture if there is not already one equivalent (according to eq, see EggTexture.is_equivalent_to()) to the indicated texture, or returns the existing one if there is.
int | extractTextures (EggGroupNode node)
| Walks the egg hierarchy beginning at the indicated node, and removes any EggTextures encountered in the hierarchy, adding them to the collection.
EggTexture | findFilename (Filename const filename)
| Returns the texture with the indicated filename, or NULL if no texture matches.
EggTexture | findTref (string tref_name)
| Returns the texture with the indicated TRef name, or NULL if no texture matches.
int | findUsedTextures (EggNode node)
| Walks the egg hierarchy beginning at the indicated node, looking for textures that are referenced by primitives but are not already members of the collection, adding them to the collection.
int | getNumTextures ()
| Returns the number of EggTextures in the collection.
EggTexture | getTexture (int index)
| Returns the nth EggTexture in the collection.
list | getTextures ()
bool | isEmpty ()
| Returns true if there are no EggTexures in the collection, false otherwise.
EggTextureCollection | operator= (EggTextureCollection const copy)
EggTexture | operator[] (unsigned int n)
| Returns the nth EggTexture in the collection.
bool | removeTexture (EggTexture texture)
| Explicitly removes a texture from the collection.
| removeUnusedTextures (EggNode node)
| Removes any textures from the collection that aren't referenced by any primitives in the indicated egg hierarchy.
unsigned int | size ()
| Returns the number of EggTextures in the collection.
| sortByBasename ()
| Sorts all the textures into alphabetical order by the basename part (including extension) of the filename.
| sortByTref ()
| Sorts all the textures into alphabetical order by TRef name.
| uniquifyTrefs ()
| Guarantees that each texture in the collection has a unique TRef name.
## Static Public Member Functions
static | replaceTextures (EggGroupNode node, mapPointerToEggTexture, PointerToEggTexture const replace)
| Walks the egg hierarchy, changing out any reference to a texture appearing on the left side of the map with its corresponding texture on the right side.

## Detailed Description

This is a collection of textures by TRef name.

It can extract the textures from an egg file and sort them all together; it can also manage the creation of unique textures and the assignment of unique TRef names.

## Constructor & Destructor Documentation

EggTextureCollection | ( |  | ) |

EggTextureCollection | ( | EggTextureCollection const | copy | ) |

## Member Function Documentation

bool addTexture | ( | EggTexture | texture | ) |

Explicitly adds a new texture to the collection.

Returns true if the texture was added, false if it was already there or if there was some error.

clear | ( |  | ) |

Removes all textures from the collection.

int collapseEquivalentTextures | ( | int | eq,
|  | EggGroupNode | node
| ) |  |

Walks through the collection and collapses together any separate textures that are equivalent according to the indicated equivalence factor, eq (see EggTexture.is_equivalent_to()).

The return value is the number of textures removed.

This flavor of collapse_equivalent_textures() automatically adjusts all the primitives in the egg hierarchy to refer to the new texture pointers.

int collapseEquivalentTextures | ( | int | eq,
|  | mapPointerToEggTexture | ,
|  | PointerToEggTexture | removed
| ) |  |

Walks through the collection and collapses together any separate textures that are equivalent according to the indicated equivalence factor, eq (see EggTexture.is_equivalent_to()).

The return value is the number of textures removed.

This flavor of collapse_equivalent_textures() does not adjust any primitives in the egg hierarchy; instead, it fills up the 'removed' map with an entry for each removed texture, mapping it back to the equivalent retained texture. It's up to the user to then call replace_textures() with this map, if desired, to apply these changes to the egg hierarchy.

EggTexture createUniqueTexture | ( | EggTexture const | copy,
|  | int | eq
| ) |  |

Creates a new texture if there is not already one equivalent (according to eq, see EggTexture.is_equivalent_to()) to the indicated texture, or returns the existing one if there is.

int extractTextures | ( | EggGroupNode | node | ) |

Walks the egg hierarchy beginning at the indicated node, and removes any EggTextures encountered in the hierarchy, adding them to the collection.

Returns the number of EggTextures encountered.

EggTexture findFilename | ( | Filename const | filename | ) |

Returns the texture with the indicated filename, or NULL if no texture matches.

EggTexture findTref | ( | string | tref_name | ) |

Returns the texture with the indicated TRef name, or NULL if no texture matches.

int findUsedTextures | ( | EggNode | node | ) |

Walks the egg hierarchy beginning at the indicated node, looking for textures that are referenced by primitives but are not already members of the collection, adding them to the collection.

If this is called following extract_textures(), it can be used to pick up any additional texture references that appeared in the egg hierarchy (but whose EggTexture node was not actually part of the hierarchy).

If this is called in lieu of extract_textures(), it will fill up the collection with all of the referenced textures (and only the referenced textures), without destructively removing the EggTextures from the hierarchy.

This also has the side effect of incrementing the internal usage count for a texture in the collection each time a texture reference is encountered. This side effect is taken advantage of by remove_unused_textures().

And one more side effect: this function identifies the presence of multitexturing in the egg file, and calls multitexture_over() on each texture appropriately so that, after this call, you may expect get_multitexture_sort() to return a reasonable value for each texture.

int getNumTextures | ( |  | ) |

Returns the number of EggTextures in the collection.

EggTexture getTexture | ( | int | index | ) |

Returns the nth EggTexture in the collection.

list getTextures | ( |  | ) |

bool isEmpty | ( |  | ) |

Returns true if there are no EggTexures in the collection, false otherwise.

EggTextureCollection operator= | ( | EggTextureCollection const | copy | ) |

EggTexture operator[] | ( | unsigned int | n | ) |

Returns the nth EggTexture in the collection.

bool removeTexture | ( | EggTexture | texture | ) |

Explicitly removes a texture from the collection.

Returns true if the texture was removed, false if it wasn't there or if there was some error.

removeUnusedTextures | ( | EggNode | node | ) |

Removes any textures from the collection that aren't referenced by any primitives in the indicated egg hierarchy.

This also, incidentally, adds textures to the collection that had been referenced by primitives but had not previously appeared in the collection.

static replaceTextures | ( | EggGroupNode | node,
|  | mapPointerToEggTexture | ,
|  | PointerToEggTexture const | replace
| ) |  | `[static]`

Walks the egg hierarchy, changing out any reference to a texture appearing on the left side of the map with its corresponding texture on the right side.

This is most often done following a call to collapse_equivalent_textures(). It does not directly affect the Collection.

unsigned int size | ( |  | ) |

Returns the number of EggTextures in the collection.

sortByBasename | ( |  | ) |

Sorts all the textures into alphabetical order by the basename part (including extension) of the filename.

Subsequent operations using begin()/end() will traverse in this sorted order.

sortByTref | ( |  | ) |

Sorts all the textures into alphabetical order by TRef name.

Subsequent operations using begin()/end() will traverse in this sorted order.

uniquifyTrefs | ( |  | ) |

Guarantees that each texture in the collection has a unique TRef name.

This is essential before writing an egg file.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties